import json

from .constants import PYTHON3

if PYTHON3:
    from urllib.parse import parse_qs
else:
    from urlparse import parse_qs


class POST:
    def __init__(self, environ, is_file=False):
        self.query_string = environ.get('QUERY_STRING')
        self.environ = environ
        self.parameters = {}
        self.parameter = self.parameter
        if not is_file:
            content_length = int(environ.get('CONTENT_LENGTH'))
            self.__parse_args(content_length)

    def __parse_args(self, length):
        parameters = self.__get_data(length)

        if parameters:
            self.parameters.update(parameters)

    def parameter(self, key):
        '''
        GET request parameters eg name=john
        :param key: eg name
        :return: Value of key eg john
        '''
        if key in self.parameters.keys():
            return self.parameters[key]
        return None

    def __get_data(self, length):
        field_data = self.environ['wsgi.input'].read(length)
        # check if data is json string
        try:
            json_data = json.loads(field_data);
            return json_data
        except:
            pass

        return parse_qs(field_data)

    def __getitem__(self, item):
        if item == 'fields':
            return self.parameters
        else:
            if item in self.parameters.keys():
                return self.parameters[item]
        return None

    def fields(self):
        import cgi
        fields = cgi.FieldStorage(fp=self.environ['wsgi.input'], environ=self.environ, keep_blank_values=0)
        return fields
